/* 
 * module.h
 *
 * Routines to access the different modules.
 *
 * Copyright (C) 1997,1998 Hermann Samso
 */

#ifndef MODULE_H
#define MODULE_H

typedef struct MODULE {
	struct MODULE* next;
	struct MODULE* previous;
	CHAR* name;
	CHAR* version;
	void	(*init)		(void);
	void	(*exit)		(void);
	void	(*ctrl)		(INT input);
	void	(*exec)		(void);
	void	(*display)	(void);
} MODULE;

void ModuleRegisterAll(void);
void ModuleRegister(MODULE* mod);
BOOL ModuleHasMore(void);
INT ModuleHowMany(void);
void ModuleFirst(void);
void ModuleNext(void);
void ModulePrevious(void);
CHAR* ModuleGetName(void);
void ModuleSelectByName(CHAR* name);
void ModuleInit(void);
void ModuleExit(void);
void ModuleCtrl(INT input);
void ModuleExec(void);
void ModuleDisplay(void);

/* avalilable modules */
extern MODULE vol_mod;
extern MODULE wave_mod;
extern MODULE actualizer_mod;
extern MODULE noise_mod;
extern MODULE echo_mod;
extern MODULE mixer_mod;

#endif
